# Fg42 - Emacs Editor for advance users
#
# Copyright (c) 2010-2024 Sameer Rahmani <lxsameer@gnu.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
{ emacsPackages, writeTextFile, ... }:
{
  makeDesktopFile = { };

  makeFG42Drv = { pname, version, ... }@args:
    (emacsPackages.trivialBuild args).overrideAttrs (old: {
      pname = "fg42-${pname}";

      installPhase = ''
        runHook preInstall

        LISPDIR=$out/share/emacs/
        install -d $LISPDIR
        cp -rv lisp/ $LISPDIR/site-lisp

        emacs --batch -l package --eval "(package-generate-autoloads \"${args.pname}\" \"$LISPDIR/site-lisp\")"

        runHook postInstall
      '';

    });

}
