;;; FG42 --- The mighty editor for the emacsians -*- lexical-binding: t; -*-
;;
;; Copyright (c) 2010-2024 Sameer Rahmani <lxsameer@gnu.org>
;;
;; Author: Sameer Rahmani <lxsameer@gnu.org>
;; URL: https://devheroes.codes/FG42/FG42
;; Version: 4.0.0
;;
;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;
;;; Commentary:
;;; Code:
;; ============================================================================
;; Basic inital configuration for FG42's operations
;; ============================================================================
(require 'fg42/utils)

(defgroup fg42 nil
  "Customize your FG42 instance via this group of configurations."
  :group :editor)

(defvar fg42/disabled-features nil
  "List of features to disable.")

(defvar fg42/after-init-hook nil
  "The hook tha runs when FG42 finished running the user configuration.")

(defvar fg42/debug? nil
  "It is t If FG42 is running in debug mode and nil otherwise.")

(defvar fg42/-gc-cons-threshold 16777216
  "Value of GC threshold of FG42.")

(defvar fg42/initialized nil
  "A variable that indicates whether FG42 is passed initialization.")


(defconst fg42/cache-dir (or (getenv "FG42_CACHE_DIR")
                             (path-join (or (getenv "XDG_CACHE_HOME") "~/.cache")
                                        "fg42")))


(defconst fg42/config-dir (or (getenv "FG42_CONFIG_DIR")
                              (path-join (or (getenv "XDG_CONFIG_HOME") "~/.config")
                                         "fg42")))

(defvar fg42/before-user-config-init-hook nil
  "A hook that runs before loading user's configuration.")

(defvar fg42/after-user-config-init-hook nil
  "A hook that runs after loading user's configuration.")


(provide 'fg42/pre)
;;; pre.el ends here
